﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class OrbesEngine : MonoBehaviour {

    public int TimeLevel = 60;
    public int OrbesMax = 30;
    private float timePerOrbe;

    public float Radio = 1.0f;
    
    public float degreesPerSecondMin = 10;
    public float degreesPerSecond ;
    private float degreesAcum;
    public float degreesPerSecondMax = 100;

    public int OrbesExtra = 0;
    private int contOrb;
    private int TimeAparicion;
    private int TimeAcum;
    private TiempoEngine Tiempo;
    private int Dir;

    public GameObject[] life;
    private int ContLife;
    private int NumberLife;

    private GameObject[] Orbs;
    private GameObject aux;
    private Vector3[] DisIni;
    private float secs; 

    public Color32[] color;

    public bool Error;

    public GameObject Score;
    public int ValorPunto = 3;
    public int Puntos;
    public int MaxPuntos;
    private Text MultiText;
    public int MultiInt;
    public int MultiPerOrbes = 5;
    private int MultiAcumPerOrbes;
    public int AcumOrbes;
    private int FontEffect;
    private int FontSizeAux;


    void Awake()
    {
        Orbs = GameObject.FindGameObjectsWithTag("Orbes");
        DisIni = new Vector3[Orbs.Length];
        OrdenarOrbes();
        
    }

	void Start ()
    {
        Error = false;
        FontEffect = 0;

        NumberLife = life.Length;

        Tiempo = GameObject.Find("Tiempo").GetComponent<TiempoEngine>();
        MultiText = GameObject.Find("Multiplicador").GetComponent<Text>();
        MultiText.text = "";

        timePerOrbe = TimeLevel / OrbesMax;
        TimeAcum = TimeAparicion = TimeLevel / (OrbesExtra + 1);
        
        degreesPerSecond = degreesPerSecondMin;
        degreesAcum = (degreesPerSecondMax - degreesPerSecondMin) / TimeLevel;

        MultiAcumPerOrbes = MultiPerOrbes;
        Dir = 1;
        Puntos = 0;
        MultiInt = 1;
        secs = 0;
        ContLife = 0;
        contOrb = AcumOrbes = 0;
            
	}
	
	
	void Update ()
    {
        degreesPerSecond += degreesAcum * Time.deltaTime;

        if(FontEffect > 0)
        {
            StartCoroutine(EfectoFont(0, MultiText, 2, 0.1f));
                
        }

        if(AcumOrbes >= MultiAcumPerOrbes)
        {
            FontEffect = 1;
            FontSizeAux = MultiText.fontSize;
            MultiText.color = Random.ColorHSV(0, 1, 0, 1, 0, 1, 1, 1);
            MultiAcumPerOrbes += MultiPerOrbes;
            MultiInt++;
            MultiText.text = "X" + MultiInt.ToString();
        }

        if(contOrb < OrbesMax && Tiempo.secsprogres == TimeAcum )
        {
            StartCoroutine(AparicionOrbe());
            OrdenarOrbes();
            TimeAcum += TimeAparicion;
        }
        else
            for (int i = 0; i < Orbs.Length; i++)
            {
                DisIni[i] = Quaternion.AngleAxis(degreesPerSecond * Dir * Time.deltaTime, Vector3.forward) * DisIni[i];
                Orbs[i].GetComponent<BotonEngine>().Target = transform.position + DisIni[i];
            }

        Score.GetComponent<Text>().text = Puntos.ToString("000");
	    
        ControlTime();
	}

    void ControlTime()
    {
        if(secs < timePerOrbe)
        {
            secs += Time.deltaTime;
        }
        else
        {
            if (!Error)
            {
                if (aux != null && aux.gameObject.GetComponent<BotonEngine>().IsActivo)
                {
                    // RestaLifes();
                    MultiInt = 1;
                    aux.GetComponent<SpriteRenderer>().color = Color.clear;
                }
            }
            else
                Error = false;
                
            OrbeAleatoria();
            secs = 0;
        }
        
    }

    void OrbeAleatoria()
    {
        int x = Random.Range(0, Orbs.Length);
        Orbs[x].GetComponent<SpriteRenderer>().color = color[x];
        Orbs[x].gameObject.GetComponent<BotonEngine>().IsActivo = true;
        aux = Orbs[x].gameObject;
    }

   public void RestaLifes()
    {
        NumberLife--;
        AcumOrbes = 0;

        MultiInt = 1;

        life[ContLife].gameObject.SetActive(false);
        ContLife++;
        if (NumberLife == 0)
            Application.LoadLevel(5);
    }

    void OrdenarOrbes()
    {
        for (int i = 0; i < Orbs.Length; i++)
        {
            float angle = i * Mathf.PI * 2 / Orbs.Length;
            Orbs[i].GetComponent<BotonEngine>().Target = new Vector3(Mathf.Cos(angle), Mathf.Sin(angle), 0) * Radio;
            DisIni[i] = Orbs[i].GetComponent<BotonEngine>().Target - transform.position;
        }
    }

    IEnumerator AparicionOrbe()
    {
        Instantiate(Orbs[0].gameObject, transform.position, Quaternion.identity);
        Orbs = GameObject.FindGameObjectsWithTag("Orbes");
        DisIni = new Vector3[Orbs.Length];
        Dir *= -1;

        yield return new WaitForSeconds(1);

    }

    public IEnumerator EfectoFont(int i, Text t, int N, float c)
    {
        while(i < N / c)
        {
            t.fontSize++;
            i++;
            yield return new  WaitForSeconds(c);
        }
        t.fontSize = FontSizeAux;
        FontEffect = 0;
        t.text = "";
    }
    
}
